
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Revision_approvalsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const revision_approvals = await db.revision_approvals.create(
            {
                id: data.id || undefined,
        
        decision: data.decision
        ||
        null
            ,
            
        decided_at: data.decided_at
        ||
        null
            ,
            
        comment: data.comment
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await revision_approvals.setDocument_revision( data.document_revision || null, {
            transaction,
        });
        
        await revision_approvals.setContract_participant( data.contract_participant || null, {
            transaction,
        });
        
        await revision_approvals.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return revision_approvals;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const revision_approvalsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                decision: item.decision
            ||
            null
            ,
            
                decided_at: item.decided_at
            ||
            null
            ,
            
                comment: item.comment
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const revision_approvals = await db.revision_approvals.bulkCreate(revision_approvalsData, { transaction });

        // For each item created, replace relation files
        

        return revision_approvals;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const revision_approvals = await db.revision_approvals.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.decision !== undefined) updatePayload.decision = data.decision;
        
        
        if (data.decided_at !== undefined) updatePayload.decided_at = data.decided_at;
        
        
        if (data.comment !== undefined) updatePayload.comment = data.comment;
        
        
        updatePayload.updatedById = currentUser.id;

        await revision_approvals.update(updatePayload, {transaction});

        
        
        if (data.document_revision !== undefined) {
            await revision_approvals.setDocument_revision(
              
              data.document_revision,
              
              { transaction }
            );
        }
        
        if (data.contract_participant !== undefined) {
            await revision_approvals.setContract_participant(
              
              data.contract_participant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await revision_approvals.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return revision_approvals;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const revision_approvals = await db.revision_approvals.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of revision_approvals) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of revision_approvals) {
                await record.destroy({transaction});
            }
        });


        return revision_approvals;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const revision_approvals = await db.revision_approvals.findByPk(id, options);

        await revision_approvals.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await revision_approvals.destroy({
            transaction
        });

        return revision_approvals;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const revision_approvals = await db.revision_approvals.findOne(
            { where },
            { transaction },
        );

        if (!revision_approvals) {
            return revision_approvals;
        }

        const output = revision_approvals.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.document_revision = await revision_approvals.getDocument_revision({
            transaction
        });
        
        
        output.contract_participant = await revision_approvals.getContract_participant({
            transaction
        });
        
        
        output.organizations = await revision_approvals.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.document_revisions,
        as: 'document_revision',
        
        where: filter.document_revision ? {
          [Op.or]: [
            { id: { [Op.in]: filter.document_revision.split('|').map(term => Utils.uuid(term)) } },
            {
              change_summary: {
                [Op.or]: filter.document_revision.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.contract_participants,
        as: 'contract_participant',
        
        where: filter.contract_participant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contract_participant.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.contract_participant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.comment) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'revision_approvals',
                        'comment',
                        filter.comment,
                    ),
                };
            }
            

            
            

            
            if (filter.decided_atRange) {
                const [start, end] = filter.decided_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    decided_at: {
                    ...where.decided_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    decided_at: {
                    ...where.decided_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.decision) {
                where = {
                    ...where,
                decision: filter.decision,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.revision_approvals.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'revision_approvals',
                        'decision',
                        query,
                    ),
                ],
            };
        }

        const records = await db.revision_approvals.findAll({
            attributes: [ 'id', 'decision' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['decision', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.decision,
        }));
    }

    
};

